/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 3.0.12
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package it.politecnico.coolprop;

public class SsatSimpleState extends SimpleState {
  private transient long swigCPtr;

  protected SsatSimpleState(long cPtr, boolean cMemoryOwn) {
    super(CoolPropJNI.SsatSimpleState_SWIGUpcast(cPtr), cMemoryOwn);
    swigCPtr = cPtr;
  }

  protected static long getCPtr(SsatSimpleState obj) {
    return (obj == null) ? 0 : obj.swigCPtr;
  }

  protected void finalize() {
    delete();
  }

  public synchronized void delete() {
    if (swigCPtr != 0) {
      if (swigCMemOwn) {
        swigCMemOwn = false;
        CoolPropJNI.delete_SsatSimpleState(swigCPtr);
      }
      swigCPtr = 0;
    }
    super.delete();
  }

  public void setExists(SsatSimpleState.SsatSimpleStateEnum value) {
    CoolPropJNI.SsatSimpleState_exists_set(swigCPtr, this, value.swigValue());
  }

  public SsatSimpleState.SsatSimpleStateEnum getExists() {
    return SsatSimpleState.SsatSimpleStateEnum.swigToEnum(CoolPropJNI.SsatSimpleState_exists_get(swigCPtr, this));
  }

  public SsatSimpleState() {
    this(CoolPropJNI.new_SsatSimpleState(), true);
  }

  public final static class SsatSimpleStateEnum {
    public final static SsatSimpleState.SsatSimpleStateEnum SSAT_MAX_NOT_SET = new SsatSimpleState.SsatSimpleStateEnum("SSAT_MAX_NOT_SET", CoolPropJNI.SsatSimpleState_SSAT_MAX_NOT_SET_get());
    public final static SsatSimpleState.SsatSimpleStateEnum SSAT_MAX_DOESNT_EXIST = new SsatSimpleState.SsatSimpleStateEnum("SSAT_MAX_DOESNT_EXIST");
    public final static SsatSimpleState.SsatSimpleStateEnum SSAT_MAX_DOES_EXIST = new SsatSimpleState.SsatSimpleStateEnum("SSAT_MAX_DOES_EXIST");

    public final int swigValue() {
      return swigValue;
    }

    public String toString() {
      return swigName;
    }

    public static SsatSimpleStateEnum swigToEnum(int swigValue) {
      if (swigValue < swigValues.length && swigValue >= 0 && swigValues[swigValue].swigValue == swigValue)
        return swigValues[swigValue];
      for (int i = 0; i < swigValues.length; i++)
        if (swigValues[i].swigValue == swigValue)
          return swigValues[i];
      throw new IllegalArgumentException("No enum " + SsatSimpleStateEnum.class + " with value " + swigValue);
    }

    private SsatSimpleStateEnum(String swigName) {
      this.swigName = swigName;
      this.swigValue = swigNext++;
    }

    private SsatSimpleStateEnum(String swigName, int swigValue) {
      this.swigName = swigName;
      this.swigValue = swigValue;
      swigNext = swigValue+1;
    }

    private SsatSimpleStateEnum(String swigName, SsatSimpleStateEnum swigEnum) {
      this.swigName = swigName;
      this.swigValue = swigEnum.swigValue;
      swigNext = this.swigValue+1;
    }

    private static SsatSimpleStateEnum[] swigValues = { SSAT_MAX_NOT_SET, SSAT_MAX_DOESNT_EXIST, SSAT_MAX_DOES_EXIST };
    private static int swigNext = 0;
    private final int swigValue;
    private final String swigName;
  }

}
